package Tutorial2.Exercises_2;

import net.beadsproject.beads.data.Buffer;
import net.beadsproject.beads.ugens.Envelope;
import net.beadsproject.beads.ugens.Gain;
import net.beadsproject.beads.ugens.WavePlayer;
import net.happybrackets.core.HBAction;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

/*
 * Created by Garth Paine, June 2020
 * This patch demonstrates the extension of the HelloSound patch to use enveloped
 * to change the amplitude of the output and
 *
 * here the oscillator is always playing even though the amplitude is turned down to zero
 *
 * Try adding a KillTrigger which will allow us to remove the oscillator when it has finished playing to save processing cycles
 *
 * Look at the other notes in the patch outlining tasks for you to complete
 *
 * */

public class Exercise_SoundEnvelop implements HBAction {
    @Override
    public void action(HB hb) {
        //Clears any running code on the device
        hb.reset();

        //Write your sketch below

      //  float START_FREQUENCY = 300;
        //create envelop to control gain
        Envelope eGain = new Envelope(0f);
        // add segments to the envelop - like an ASR or ADSR envelop
        //Important - these segments are added at compile time not during the runtime
        eGain.addSegment(0.5f, 100);
        eGain.addSegment(0.3f, 50);
        eGain.addSegment(0.2f, 2000);
        eGain.addSegment(0f, 1000);

/*        Envelope ePitch = new Envelope(START_FREQUENCY);
        ePitch.addSegment(600, 1000);
        ePitch.addSegment(50, 20);
        ePitch.addSegment(startPitch, 2000);*/

        //create waveplayer
        WavePlayer wp = new WavePlayer(300, Buffer.SINE);
        //WavePlayer wp = new WavePlayer(ePitch, Buffer.SINE); //for use with pitch envelop
        //create gain object
        Gain g = new Gain(1, eGain);
        //add wave player to gain object input
        g.addInput(wp);

        //send to output
        hb.sound(g);

        //Exercise
        //add an envelop to control the pitch of the sound

        //Exercise 2
        //How can you make this patch play 4 times?

        //Extra - Advanced
        //use Pitch - then use an array to play a set of pitches


        // write your code above this line
    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
