package Tutorial2.Exercises_2;

import net.beadsproject.beads.data.Buffer;
import net.beadsproject.beads.events.KillTrigger;
import net.beadsproject.beads.ugens.Envelope;
import net.beadsproject.beads.ugens.Gain;
import net.beadsproject.beads.ugens.WavePlayer;
import net.happybrackets.core.HBAction;
import net.happybrackets.core.scheduling.Clock;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

/*
 * Created by Garth Paine, June 2020
 * This patch demonstrates the use of two clock listeners running at different rates.
 * One generates a melody note
 * the other generates a short noise pulse to act as a kind of snare/HHat sound
 *
 * Take note of the use of the KillTrigger in the envelop generation
 *
 * Hack and enjoy
 *
 * nb. note that envelope segments are generated at compile time
 *
 * */

public class Extra_TwoClockMelody implements HBAction {
    @Override
    public void action(HB hb) {
        hb.reset(); //Clears any running code on the device


        // To create this, just type clockTimer
        Clock clock = HB.createClock(1000).addClockTickListener((offset, this_clock) -> {// Write your code below this line

            WavePlayer wp = new WavePlayer((500f + ((hb.rng.nextFloat()*300f))), Buffer.SINE);

            Envelope eWave = new Envelope(0f);
            eWave.addSegment(0.6f, 10);
            eWave.addSegment(0.3f, 1000);

            Gain gainWavePlayer = new Gain(1, eWave);

            eWave.addSegment(0.3f, 0, new KillTrigger(gainWavePlayer));

            gainWavePlayer.addInput(wp);

            hb.sound(gainWavePlayer);
            // Write your code above this line 
        });

        clock.start();// End Clock Timer 

// To create this, just type clockTimer
        Clock clock2 = HB.createClock(250   ).addClockTickListener((offset, this_clock) -> {// Write your code below this line

            WavePlayer wpNoise = new WavePlayer((1000f + ((hb.rng.nextFloat()*300f))), Buffer.NOISE);

            Envelope eWave = new Envelope(0f);
            eWave.addSegment(0.7f, 10);
            eWave.addSegment(0.3f, 30);

            Gain gainWavePlayerNoise = new Gain(1, eWave);

            eWave.addSegment(0f, 10, new KillTrigger(gainWavePlayerNoise));

            gainWavePlayerNoise.addInput(wpNoise);

            hb.sound(gainWavePlayerNoise);

            // Write your code above this line
        });

        clock2.start();// End Clock Timer
    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
