package Tutorial2;

import net.beadsproject.beads.data.Buffer;
import net.beadsproject.beads.ugens.Gain;
import net.beadsproject.beads.ugens.WavePlayer;
import net.happybrackets.core.HBAction;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

/*
 * Created by Garth Paine, June 2020
 * This patch demonstrates the most basic construction of an oscillator
 *
 * */
public class HelloSound implements HBAction {
    @Override
    public void action(HB hb) {
        hb.reset(); //Clears any running code on the device

        //waveplayer to synthesis sound
        WavePlayer wp = new WavePlayer(200f, Buffer.SAW);
        //Gain object to control output volume
        Gain g = new Gain(1, 0.3f);
        //plug waveplayer into gain input
        g.addInput(wp);
        //connect gain object to sound output hardware
        hb.sound(g);

        // write your code above this line
    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
