package Tutorial2.Other;

import net.beadsproject.beads.data.Sample;
import net.beadsproject.beads.data.SampleManager;
import net.beadsproject.beads.ugens.Gain;
import net.beadsproject.beads.ugens.GranularSamplePlayer;
import net.beadsproject.beads.ugens.SamplePlayer;
import net.happybrackets.core.HBAction;
import net.happybrackets.core.scheduling.Clock;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

public class DDSampler implements HBAction {
    @Override
    public void action(HB hb) {
        hb.reset(); //Clears any running code on the device


        //Write your sketch below

        //Sample s = SampleManager.sample("data/audio/Drums/02CountrySide.wav");
        SampleManager.group("Drums", "data/audio/Drums/");
        SampleManager.group("Guitar", "data/audio/Nylon_Guitar/");



        Sample s = SampleManager.randomFromGroup("Drums");

        GranularSamplePlayer gsp = new GranularSamplePlayer(s);
        //gsp.setLoopType(SamplePlayer.LoopType.LOOP_ALTERNATING);

        Gain g = new Gain(1, 0.8f);

        g.addInput(gsp);

        hb.sound(g);


        // To create this, just type clockTimer
        Clock clock = HB.createClock(250).addClockTickListener((offset, this_clock) -> {// Write your code below this line

            Sample s2 = SampleManager.randomFromGroup("Guitar");

            SamplePlayer sp2 = new SamplePlayer(s2);
            //sp2.setLoopType(SamplePlayer.LoopType.LOOP_ALTERNATING);

            Gain g2 = new Gain(1, 0.2f);

            g2.addInput(sp2);

            hb.sound(g2);


            // Write your code above this line
        });

        clock.start();// End Clock Timer












        // write your code above this line
    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
