package Tutorial2.Other;

import net.beadsproject.beads.data.Sample;
import net.beadsproject.beads.data.SampleManager;
import net.beadsproject.beads.ugens.*;
import net.happybrackets.core.HBAction;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

public class SamplePlayback implements HBAction {
    @Override
    public void action(HB hb) {

        hb.reset();
        //hb.resetLeaveSounding();
        //hb.fadeOutReset(2000);

        //hb.reset();  //Clears any running code on the device

        Gain g = new Gain(hb.ac,1, 0.7f);


        Sample s = SampleManager.sample("data/audio/Drums/105a.wav");
        //Sample s = SampleManager.sample("data/audio/Drums/02CountrySide.wav");
        float sampleLength = (float) s.getLength();


        GranularSamplePlayer gsp = new GranularSamplePlayer(hb.ac, s);
        gsp.setLoopType(SamplePlayer.LoopType.LOOP_ALTERNATING);


        gsp.getRandomnessUGen().setValue(0.1f);

        //comment when not in use
        gsp.getGrainIntervalUGen().setValue(120); //60, 120,   5
        gsp.getGrainSizeUGen().setValue(800); //30,  2,  120, 800

        Envelope loopEnd = new Envelope(hb.ac, sampleLength);

        float loopSetEnd = (sampleLength * ((hb.rng.nextFloat() + 1)/2.0f));


        System.out.println(loopSetEnd + " loopSetEnd");
        loopEnd.addSegment(loopSetEnd, sampleLength*2);
        loopEnd.addSegment(loopSetEnd/2, sampleLength);
        loopEnd.addSegment(loopSetEnd, sampleLength);
        loopEnd.addSegment(loopSetEnd/16, sampleLength*2);
        loopEnd.addSegment(loopSetEnd, sampleLength);
        gsp.setLoopEnd(loopEnd);

        g.addInput(gsp);
        hb.sound(g);

        int myIndex = hb.myIndex();
        hb.setStatus("" + Math.abs(myIndex));



    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
