package Tutorial2;

import net.beadsproject.beads.data.Sample;
import net.beadsproject.beads.data.SampleManager;
import net.beadsproject.beads.events.KillTrigger;
import net.beadsproject.beads.ugens.Envelope;
import net.beadsproject.beads.ugens.Gain;
import net.beadsproject.beads.ugens.SamplePlayer;
import net.happybrackets.core.HBAction;
import net.happybrackets.device.HB;

import java.lang.invoke.MethodHandles;

public class SamplesStarter implements HBAction {
    @Override
    public void action(HB hb) {
        hb.reset();

        // once the sample player finishes the sample it kills itself
        Sample s = SampleManager.sample("data/audio/Nylon_Guitar/Clean_A_harm.wav");
        SamplePlayer samplePlayer = new SamplePlayer(s);
        float sampleLength = (float) s.getLength(); //returns length of sample in ms

        Envelope eRate = new Envelope(0.5f);
        Gain g = new Gain( 1, 0.7f);

        for (int i = 0; i<10; i++) {
            eRate.addSegment(4.0f, sampleLength/2);
            eRate.addSegment(0.125f, sampleLength/2);
        }

        eRate.addSegment(0f, sampleLength, new KillTrigger(g));


        samplePlayer.setPitch(eRate); //these 2 functions do the same thing


        samplePlayer.setLoopType(SamplePlayer.LoopType.LOOP_ALTERNATING);


        g.addInput(samplePlayer);


        hb.sound(g);

    }


    //<editor-fold defaultstate="collapsed" desc="Debug Start">

    /**
     * This function is used when running sketch in IntelliJ IDE for debugging or testing
     *
     * @param args standard args required
     */
    public static void main(String[] args) {

        try {
            HB.runDebug(MethodHandles.lookup().lookupClass());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //</editor-fold>
}
